/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Net.Mime;
using Coscine.ApiClient.Core.Client;
using Coscine.ApiClient.Core.Model;

namespace Coscine.ApiClient.Core.Api
{

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IResourceTypeApiSync : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint.
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns></returns>
        void ApiV2ResourceTypesOptions(int operationIndex = 0);

        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> ApiV2ResourceTypesOptionsWithHttpInfo(int operationIndex = 0);
        /// <summary>
        /// Retrieves all branches of a GitLab project, that the user is a member of, based on the provided credentials.
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>GitlabBranchDtoIEnumerableResponse</returns>
        GitlabBranchDtoIEnumerableResponse GetAllGitlabBranchesForProject(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0);

        /// <summary>
        /// Retrieves all branches of a GitLab project, that the user is a member of, based on the provided credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of GitlabBranchDtoIEnumerableResponse</returns>
        ApiResponse<GitlabBranchDtoIEnumerableResponse> GetAllGitlabBranchesForProjectWithHttpInfo(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0);
        /// <summary>
        /// Retrieves all GitLab projects, that the user is a member of, based on the provided credentials.
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>GitlabProjectDtoIEnumerableResponse</returns>
        GitlabProjectDtoIEnumerableResponse GetAllGitlabProjects(string domain, string accessToken, int operationIndex = 0);

        /// <summary>
        /// Retrieves all GitLab projects, that the user is a member of, based on the provided credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of GitlabProjectDtoIEnumerableResponse</returns>
        ApiResponse<GitlabProjectDtoIEnumerableResponse> GetAllGitlabProjectsWithHttpInfo(string domain, string accessToken, int operationIndex = 0);
        /// <summary>
        /// Retrieves the entire global resource types information.
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ResourceTypeInformationDtoIEnumerableResponse</returns>
        ResourceTypeInformationDtoIEnumerableResponse GetAllResourceTypesInformation(int operationIndex = 0);

        /// <summary>
        /// Retrieves the entire global resource types information.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of ResourceTypeInformationDtoIEnumerableResponse</returns>
        ApiResponse<ResourceTypeInformationDtoIEnumerableResponse> GetAllResourceTypesInformationWithHttpInfo(int operationIndex = 0);
        /// <summary>
        /// Retrieves a single GitLab project, that the user is a member of, based on the provided credentials.
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>GitlabProjectDtoResponse</returns>
        GitlabProjectDtoResponse GetGitlabProject(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0);

        /// <summary>
        /// Retrieves a single GitLab project, that the user is a member of, based on the provided credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of GitlabProjectDtoResponse</returns>
        ApiResponse<GitlabProjectDtoResponse> GetGitlabProjectWithHttpInfo(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0);
        /// <summary>
        /// Retrieves the resource type information for a specific resource type.
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="resourceTypeId">The ID of the resource type to retrieve.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ResourceTypeInformationDtoResponse</returns>
        ResourceTypeInformationDtoResponse GetResourceTypeInformation(Guid resourceTypeId, int operationIndex = 0);

        /// <summary>
        /// Retrieves the resource type information for a specific resource type.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="resourceTypeId">The ID of the resource type to retrieve.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of ResourceTypeInformationDtoResponse</returns>
        ApiResponse<ResourceTypeInformationDtoResponse> GetResourceTypeInformationWithHttpInfo(Guid resourceTypeId, int operationIndex = 0);
        #endregion Synchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IResourceTypeApiAsync : IApiAccessor
    {
        #region Asynchronous Operations
        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task ApiV2ResourceTypesOptionsAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> ApiV2ResourceTypesOptionsWithHttpInfoAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Retrieves all branches of a GitLab project, that the user is a member of, based on the provided credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of GitlabBranchDtoIEnumerableResponse</returns>
        System.Threading.Tasks.Task<GitlabBranchDtoIEnumerableResponse> GetAllGitlabBranchesForProjectAsync(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Retrieves all branches of a GitLab project, that the user is a member of, based on the provided credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (GitlabBranchDtoIEnumerableResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<GitlabBranchDtoIEnumerableResponse>> GetAllGitlabBranchesForProjectWithHttpInfoAsync(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Retrieves all GitLab projects, that the user is a member of, based on the provided credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of GitlabProjectDtoIEnumerableResponse</returns>
        System.Threading.Tasks.Task<GitlabProjectDtoIEnumerableResponse> GetAllGitlabProjectsAsync(string domain, string accessToken, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Retrieves all GitLab projects, that the user is a member of, based on the provided credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (GitlabProjectDtoIEnumerableResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<GitlabProjectDtoIEnumerableResponse>> GetAllGitlabProjectsWithHttpInfoAsync(string domain, string accessToken, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Retrieves the entire global resource types information.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ResourceTypeInformationDtoIEnumerableResponse</returns>
        System.Threading.Tasks.Task<ResourceTypeInformationDtoIEnumerableResponse> GetAllResourceTypesInformationAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Retrieves the entire global resource types information.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (ResourceTypeInformationDtoIEnumerableResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResourceTypeInformationDtoIEnumerableResponse>> GetAllResourceTypesInformationWithHttpInfoAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Retrieves a single GitLab project, that the user is a member of, based on the provided credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of GitlabProjectDtoResponse</returns>
        System.Threading.Tasks.Task<GitlabProjectDtoResponse> GetGitlabProjectAsync(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Retrieves a single GitLab project, that the user is a member of, based on the provided credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (GitlabProjectDtoResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<GitlabProjectDtoResponse>> GetGitlabProjectWithHttpInfoAsync(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Retrieves the resource type information for a specific resource type.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="resourceTypeId">The ID of the resource type to retrieve.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ResourceTypeInformationDtoResponse</returns>
        System.Threading.Tasks.Task<ResourceTypeInformationDtoResponse> GetResourceTypeInformationAsync(Guid resourceTypeId, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Retrieves the resource type information for a specific resource type.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="resourceTypeId">The ID of the resource type to retrieve.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (ResourceTypeInformationDtoResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResourceTypeInformationDtoResponse>> GetResourceTypeInformationWithHttpInfoAsync(Guid resourceTypeId, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IResourceTypeApi : IResourceTypeApiSync, IResourceTypeApiAsync
    {

    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class ResourceTypeApi : IResourceTypeApi
    {
        private Coscine.ApiClient.Core.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceTypeApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ResourceTypeApi() : this((string)null)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceTypeApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ResourceTypeApi(string basePath)
        {
            this.Configuration = Coscine.ApiClient.Core.Client.Configuration.MergeConfigurations(
                Coscine.ApiClient.Core.Client.GlobalConfiguration.Instance,
                new Coscine.ApiClient.Core.Client.Configuration { BasePath = basePath }
            );
            this.Client = new Coscine.ApiClient.Core.Client.ApiClient(this.Configuration.BasePath);
            this.AsynchronousClient = new Coscine.ApiClient.Core.Client.ApiClient(this.Configuration.BasePath);
            this.ExceptionFactory = Coscine.ApiClient.Core.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceTypeApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public ResourceTypeApi(Coscine.ApiClient.Core.Client.Configuration configuration)
        {
            if (configuration == null) throw new ArgumentNullException("configuration");

            this.Configuration = Coscine.ApiClient.Core.Client.Configuration.MergeConfigurations(
                Coscine.ApiClient.Core.Client.GlobalConfiguration.Instance,
                configuration
            );
            this.Client = new Coscine.ApiClient.Core.Client.ApiClient(this.Configuration.BasePath);
            this.AsynchronousClient = new Coscine.ApiClient.Core.Client.ApiClient(this.Configuration.BasePath);
            ExceptionFactory = Coscine.ApiClient.Core.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceTypeApi"/> class
        /// using a Configuration object and client instance.
        /// </summary>
        /// <param name="client">The client interface for synchronous API access.</param>
        /// <param name="asyncClient">The client interface for asynchronous API access.</param>
        /// <param name="configuration">The configuration object.</param>
        public ResourceTypeApi(Coscine.ApiClient.Core.Client.ISynchronousClient client, Coscine.ApiClient.Core.Client.IAsynchronousClient asyncClient, Coscine.ApiClient.Core.Client.IReadableConfiguration configuration)
        {
            if (client == null) throw new ArgumentNullException("client");
            if (asyncClient == null) throw new ArgumentNullException("asyncClient");
            if (configuration == null) throw new ArgumentNullException("configuration");

            this.Client = client;
            this.AsynchronousClient = asyncClient;
            this.Configuration = configuration;
            this.ExceptionFactory = Coscine.ApiClient.Core.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// The client for accessing this underlying API asynchronously.
        /// </summary>
        public Coscine.ApiClient.Core.Client.IAsynchronousClient AsynchronousClient { get; set; }

        /// <summary>
        /// The client for accessing this underlying API synchronously.
        /// </summary>
        public Coscine.ApiClient.Core.Client.ISynchronousClient Client { get; set; }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public string GetBasePath()
        {
            return this.Configuration.BasePath;
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Coscine.ApiClient.Core.Client.IReadableConfiguration Configuration { get; set; }

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public Coscine.ApiClient.Core.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns></returns>
        public void ApiV2ResourceTypesOptions(int operationIndex = 0)
        {
            ApiV2ResourceTypesOptionsWithHttpInfo();
        }

        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public Coscine.ApiClient.Core.Client.ApiResponse<Object> ApiV2ResourceTypesOptionsWithHttpInfo(int operationIndex = 0)
        {
            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }


            localVarRequestOptions.Operation = "ResourceTypeApi.ApiV2ResourceTypesOptions";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Options<Object>("/api/v2/resource-types", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiV2ResourceTypesOptions", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task ApiV2ResourceTypesOptionsAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            await ApiV2ResourceTypesOptionsWithHttpInfoAsync(operationIndex, cancellationToken).ConfigureAwait(false);
        }

        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<Coscine.ApiClient.Core.Client.ApiResponse<Object>> ApiV2ResourceTypesOptionsWithHttpInfoAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }


            localVarRequestOptions.Operation = "ResourceTypeApi.ApiV2ResourceTypesOptions";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.OptionsAsync<Object>("/api/v2/resource-types", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiV2ResourceTypesOptions", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves all branches of a GitLab project, that the user is a member of, based on the provided credentials. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>GitlabBranchDtoIEnumerableResponse</returns>
        public GitlabBranchDtoIEnumerableResponse GetAllGitlabBranchesForProject(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0)
        {
            Coscine.ApiClient.Core.Client.ApiResponse<GitlabBranchDtoIEnumerableResponse> localVarResponse = GetAllGitlabBranchesForProjectWithHttpInfo(gitlabProjectId, domain, accessToken);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves all branches of a GitLab project, that the user is a member of, based on the provided credentials. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of GitlabBranchDtoIEnumerableResponse</returns>
        public Coscine.ApiClient.Core.Client.ApiResponse<GitlabBranchDtoIEnumerableResponse> GetAllGitlabBranchesForProjectWithHttpInfo(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0)
        {
            // verify the required parameter 'domain' is set
            if (domain == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'domain' when calling ResourceTypeApi->GetAllGitlabBranchesForProject");
            }

            // verify the required parameter 'accessToken' is set
            if (accessToken == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'accessToken' when calling ResourceTypeApi->GetAllGitlabBranchesForProject");
            }

            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("gitlabProjectId", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(gitlabProjectId)); // path parameter
            localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "Domain", domain));
            localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "AccessToken", accessToken));

            localVarRequestOptions.Operation = "ResourceTypeApi.GetAllGitlabBranchesForProject";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<GitlabBranchDtoIEnumerableResponse>("/api/v2/resource-types/gitlab/projects/{gitlabProjectId}/branches", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetAllGitlabBranchesForProject", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves all branches of a GitLab project, that the user is a member of, based on the provided credentials. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of GitlabBranchDtoIEnumerableResponse</returns>
        public async System.Threading.Tasks.Task<GitlabBranchDtoIEnumerableResponse> GetAllGitlabBranchesForProjectAsync(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Coscine.ApiClient.Core.Client.ApiResponse<GitlabBranchDtoIEnumerableResponse> localVarResponse = await GetAllGitlabBranchesForProjectWithHttpInfoAsync(gitlabProjectId, domain, accessToken, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves all branches of a GitLab project, that the user is a member of, based on the provided credentials. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (GitlabBranchDtoIEnumerableResponse)</returns>
        public async System.Threading.Tasks.Task<Coscine.ApiClient.Core.Client.ApiResponse<GitlabBranchDtoIEnumerableResponse>> GetAllGitlabBranchesForProjectWithHttpInfoAsync(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'domain' is set
            if (domain == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'domain' when calling ResourceTypeApi->GetAllGitlabBranchesForProject");
            }

            // verify the required parameter 'accessToken' is set
            if (accessToken == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'accessToken' when calling ResourceTypeApi->GetAllGitlabBranchesForProject");
            }


            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("gitlabProjectId", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(gitlabProjectId)); // path parameter
            localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "Domain", domain));
            localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "AccessToken", accessToken));

            localVarRequestOptions.Operation = "ResourceTypeApi.GetAllGitlabBranchesForProject";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<GitlabBranchDtoIEnumerableResponse>("/api/v2/resource-types/gitlab/projects/{gitlabProjectId}/branches", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetAllGitlabBranchesForProject", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves all GitLab projects, that the user is a member of, based on the provided credentials. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>GitlabProjectDtoIEnumerableResponse</returns>
        public GitlabProjectDtoIEnumerableResponse GetAllGitlabProjects(string domain, string accessToken, int operationIndex = 0)
        {
            Coscine.ApiClient.Core.Client.ApiResponse<GitlabProjectDtoIEnumerableResponse> localVarResponse = GetAllGitlabProjectsWithHttpInfo(domain, accessToken);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves all GitLab projects, that the user is a member of, based on the provided credentials. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of GitlabProjectDtoIEnumerableResponse</returns>
        public Coscine.ApiClient.Core.Client.ApiResponse<GitlabProjectDtoIEnumerableResponse> GetAllGitlabProjectsWithHttpInfo(string domain, string accessToken, int operationIndex = 0)
        {
            // verify the required parameter 'domain' is set
            if (domain == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'domain' when calling ResourceTypeApi->GetAllGitlabProjects");
            }

            // verify the required parameter 'accessToken' is set
            if (accessToken == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'accessToken' when calling ResourceTypeApi->GetAllGitlabProjects");
            }

            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "Domain", domain));
            localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "AccessToken", accessToken));

            localVarRequestOptions.Operation = "ResourceTypeApi.GetAllGitlabProjects";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<GitlabProjectDtoIEnumerableResponse>("/api/v2/resource-types/gitlab/projects", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetAllGitlabProjects", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves all GitLab projects, that the user is a member of, based on the provided credentials. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of GitlabProjectDtoIEnumerableResponse</returns>
        public async System.Threading.Tasks.Task<GitlabProjectDtoIEnumerableResponse> GetAllGitlabProjectsAsync(string domain, string accessToken, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Coscine.ApiClient.Core.Client.ApiResponse<GitlabProjectDtoIEnumerableResponse> localVarResponse = await GetAllGitlabProjectsWithHttpInfoAsync(domain, accessToken, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves all GitLab projects, that the user is a member of, based on the provided credentials. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (GitlabProjectDtoIEnumerableResponse)</returns>
        public async System.Threading.Tasks.Task<Coscine.ApiClient.Core.Client.ApiResponse<GitlabProjectDtoIEnumerableResponse>> GetAllGitlabProjectsWithHttpInfoAsync(string domain, string accessToken, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'domain' is set
            if (domain == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'domain' when calling ResourceTypeApi->GetAllGitlabProjects");
            }

            // verify the required parameter 'accessToken' is set
            if (accessToken == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'accessToken' when calling ResourceTypeApi->GetAllGitlabProjects");
            }


            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "Domain", domain));
            localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "AccessToken", accessToken));

            localVarRequestOptions.Operation = "ResourceTypeApi.GetAllGitlabProjects";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<GitlabProjectDtoIEnumerableResponse>("/api/v2/resource-types/gitlab/projects", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetAllGitlabProjects", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves the entire global resource types information. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ResourceTypeInformationDtoIEnumerableResponse</returns>
        public ResourceTypeInformationDtoIEnumerableResponse GetAllResourceTypesInformation(int operationIndex = 0)
        {
            Coscine.ApiClient.Core.Client.ApiResponse<ResourceTypeInformationDtoIEnumerableResponse> localVarResponse = GetAllResourceTypesInformationWithHttpInfo();
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves the entire global resource types information. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of ResourceTypeInformationDtoIEnumerableResponse</returns>
        public Coscine.ApiClient.Core.Client.ApiResponse<ResourceTypeInformationDtoIEnumerableResponse> GetAllResourceTypesInformationWithHttpInfo(int operationIndex = 0)
        {
            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }


            localVarRequestOptions.Operation = "ResourceTypeApi.GetAllResourceTypesInformation";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<ResourceTypeInformationDtoIEnumerableResponse>("/api/v2/resource-types/types", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetAllResourceTypesInformation", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves the entire global resource types information. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ResourceTypeInformationDtoIEnumerableResponse</returns>
        public async System.Threading.Tasks.Task<ResourceTypeInformationDtoIEnumerableResponse> GetAllResourceTypesInformationAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Coscine.ApiClient.Core.Client.ApiResponse<ResourceTypeInformationDtoIEnumerableResponse> localVarResponse = await GetAllResourceTypesInformationWithHttpInfoAsync(operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves the entire global resource types information. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (ResourceTypeInformationDtoIEnumerableResponse)</returns>
        public async System.Threading.Tasks.Task<Coscine.ApiClient.Core.Client.ApiResponse<ResourceTypeInformationDtoIEnumerableResponse>> GetAllResourceTypesInformationWithHttpInfoAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }


            localVarRequestOptions.Operation = "ResourceTypeApi.GetAllResourceTypesInformation";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<ResourceTypeInformationDtoIEnumerableResponse>("/api/v2/resource-types/types", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetAllResourceTypesInformation", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves a single GitLab project, that the user is a member of, based on the provided credentials. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>GitlabProjectDtoResponse</returns>
        public GitlabProjectDtoResponse GetGitlabProject(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0)
        {
            Coscine.ApiClient.Core.Client.ApiResponse<GitlabProjectDtoResponse> localVarResponse = GetGitlabProjectWithHttpInfo(gitlabProjectId, domain, accessToken);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves a single GitLab project, that the user is a member of, based on the provided credentials. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of GitlabProjectDtoResponse</returns>
        public Coscine.ApiClient.Core.Client.ApiResponse<GitlabProjectDtoResponse> GetGitlabProjectWithHttpInfo(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0)
        {
            // verify the required parameter 'domain' is set
            if (domain == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'domain' when calling ResourceTypeApi->GetGitlabProject");
            }

            // verify the required parameter 'accessToken' is set
            if (accessToken == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'accessToken' when calling ResourceTypeApi->GetGitlabProject");
            }

            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("gitlabProjectId", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(gitlabProjectId)); // path parameter
            localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "Domain", domain));
            localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "AccessToken", accessToken));

            localVarRequestOptions.Operation = "ResourceTypeApi.GetGitlabProject";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<GitlabProjectDtoResponse>("/api/v2/resource-types/gitlab/projects/{gitlabProjectId}", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetGitlabProject", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves a single GitLab project, that the user is a member of, based on the provided credentials. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of GitlabProjectDtoResponse</returns>
        public async System.Threading.Tasks.Task<GitlabProjectDtoResponse> GetGitlabProjectAsync(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Coscine.ApiClient.Core.Client.ApiResponse<GitlabProjectDtoResponse> localVarResponse = await GetGitlabProjectWithHttpInfoAsync(gitlabProjectId, domain, accessToken, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves a single GitLab project, that the user is a member of, based on the provided credentials. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="gitlabProjectId">The ID of the GitLab project.</param>
        /// <param name="domain">Domain/Host of the GitLab Provider.</param>
        /// <param name="accessToken">GitLab Project or Group Access Token.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (GitlabProjectDtoResponse)</returns>
        public async System.Threading.Tasks.Task<Coscine.ApiClient.Core.Client.ApiResponse<GitlabProjectDtoResponse>> GetGitlabProjectWithHttpInfoAsync(int gitlabProjectId, string domain, string accessToken, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'domain' is set
            if (domain == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'domain' when calling ResourceTypeApi->GetGitlabProject");
            }

            // verify the required parameter 'accessToken' is set
            if (accessToken == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'accessToken' when calling ResourceTypeApi->GetGitlabProject");
            }


            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("gitlabProjectId", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(gitlabProjectId)); // path parameter
            localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "Domain", domain));
            localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "AccessToken", accessToken));

            localVarRequestOptions.Operation = "ResourceTypeApi.GetGitlabProject";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<GitlabProjectDtoResponse>("/api/v2/resource-types/gitlab/projects/{gitlabProjectId}", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetGitlabProject", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves the resource type information for a specific resource type. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="resourceTypeId">The ID of the resource type to retrieve.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ResourceTypeInformationDtoResponse</returns>
        public ResourceTypeInformationDtoResponse GetResourceTypeInformation(Guid resourceTypeId, int operationIndex = 0)
        {
            Coscine.ApiClient.Core.Client.ApiResponse<ResourceTypeInformationDtoResponse> localVarResponse = GetResourceTypeInformationWithHttpInfo(resourceTypeId);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves the resource type information for a specific resource type. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="resourceTypeId">The ID of the resource type to retrieve.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of ResourceTypeInformationDtoResponse</returns>
        public Coscine.ApiClient.Core.Client.ApiResponse<ResourceTypeInformationDtoResponse> GetResourceTypeInformationWithHttpInfo(Guid resourceTypeId, int operationIndex = 0)
        {
            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("resourceTypeId", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(resourceTypeId)); // path parameter

            localVarRequestOptions.Operation = "ResourceTypeApi.GetResourceTypeInformation";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<ResourceTypeInformationDtoResponse>("/api/v2/resource-types/types/{resourceTypeId}", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetResourceTypeInformation", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves the resource type information for a specific resource type. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="resourceTypeId">The ID of the resource type to retrieve.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ResourceTypeInformationDtoResponse</returns>
        public async System.Threading.Tasks.Task<ResourceTypeInformationDtoResponse> GetResourceTypeInformationAsync(Guid resourceTypeId, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Coscine.ApiClient.Core.Client.ApiResponse<ResourceTypeInformationDtoResponse> localVarResponse = await GetResourceTypeInformationWithHttpInfoAsync(resourceTypeId, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves the resource type information for a specific resource type. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="resourceTypeId">The ID of the resource type to retrieve.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (ResourceTypeInformationDtoResponse)</returns>
        public async System.Threading.Tasks.Task<Coscine.ApiClient.Core.Client.ApiResponse<ResourceTypeInformationDtoResponse>> GetResourceTypeInformationWithHttpInfoAsync(Guid resourceTypeId, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("resourceTypeId", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(resourceTypeId)); // path parameter

            localVarRequestOptions.Operation = "ResourceTypeApi.GetResourceTypeInformation";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<ResourceTypeInformationDtoResponse>("/api/v2/resource-types/types/{resourceTypeId}", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetResourceTypeInformation", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

    }
}
