/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a Data Transfer Object (DTO) for language details.
    /// </summary>
    [DataContract(Name = "LanguageDto")]
    public partial class LanguageDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="LanguageDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected LanguageDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="LanguageDto" /> class.
        /// </summary>
        /// <param name="id">Gets or sets the unique identifier for the language. (required).</param>
        /// <param name="displayName">Gets or sets the display name of the language. (required).</param>
        /// <param name="abbreviation">Gets or sets the abbreviation for the language. (required).</param>
        public LanguageDto(Guid id = default(Guid), string displayName = default(string), string abbreviation = default(string))
        {
            this.Id = id;
            // to ensure "displayName" is required (not null)
            if (displayName == null)
            {
                throw new ArgumentNullException("displayName is a required property for LanguageDto and cannot be null");
            }
            this.DisplayName = displayName;
            // to ensure "abbreviation" is required (not null)
            if (abbreviation == null)
            {
                throw new ArgumentNullException("abbreviation is a required property for LanguageDto and cannot be null");
            }
            this.Abbreviation = abbreviation;
        }

        /// <summary>
        /// Gets or sets the unique identifier for the language.
        /// </summary>
        /// <value>Gets or sets the unique identifier for the language.</value>
        [DataMember(Name = "id", IsRequired = true, EmitDefaultValue = true)]
        public Guid Id { get; set; }

        /// <summary>
        /// Gets or sets the display name of the language.
        /// </summary>
        /// <value>Gets or sets the display name of the language.</value>
        [DataMember(Name = "displayName", IsRequired = true, EmitDefaultValue = true)]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets the abbreviation for the language.
        /// </summary>
        /// <value>Gets or sets the abbreviation for the language.</value>
        [DataMember(Name = "abbreviation", IsRequired = true, EmitDefaultValue = true)]
        public string Abbreviation { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class LanguageDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  DisplayName: ").Append(DisplayName).Append("\n");
            sb.Append("  Abbreviation: ").Append(Abbreviation).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
