/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing the creation of a publication request.
    /// </summary>
    [DataContract(Name = "PublicationRequestForCreationDto")]
    public partial class PublicationRequestForCreationDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PublicationRequestForCreationDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected PublicationRequestForCreationDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="PublicationRequestForCreationDto" /> class.
        /// </summary>
        /// <param name="publicationServiceRorId">The data publication service&#39;s ror id. (required).</param>
        /// <param name="resourceIds">The resource guids. (required).</param>
        /// <param name="message">A message of the requester..</param>
        public PublicationRequestForCreationDto(string publicationServiceRorId = default(string), List<Guid> resourceIds = default(List<Guid>), string message = default(string))
        {
            // to ensure "publicationServiceRorId" is required (not null)
            if (publicationServiceRorId == null)
            {
                throw new ArgumentNullException("publicationServiceRorId is a required property for PublicationRequestForCreationDto and cannot be null");
            }
            this.PublicationServiceRorId = publicationServiceRorId;
            // to ensure "resourceIds" is required (not null)
            if (resourceIds == null)
            {
                throw new ArgumentNullException("resourceIds is a required property for PublicationRequestForCreationDto and cannot be null");
            }
            this.ResourceIds = resourceIds;
            this.Message = message;
        }

        /// <summary>
        /// The data publication service&#39;s ror id.
        /// </summary>
        /// <value>The data publication service&#39;s ror id.</value>
        [DataMember(Name = "publicationServiceRorId", IsRequired = true, EmitDefaultValue = true)]
        public string PublicationServiceRorId { get; set; }

        /// <summary>
        /// The resource guids.
        /// </summary>
        /// <value>The resource guids.</value>
        [DataMember(Name = "resourceIds", IsRequired = true, EmitDefaultValue = true)]
        public List<Guid> ResourceIds { get; set; }

        /// <summary>
        /// A message of the requester.
        /// </summary>
        /// <value>A message of the requester.</value>
        [DataMember(Name = "message", EmitDefaultValue = true)]
        public string Message { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class PublicationRequestForCreationDto {\n");
            sb.Append("  PublicationServiceRorId: ").Append(PublicationServiceRorId).Append("\n");
            sb.Append("  ResourceIds: ").Append(ResourceIds).Append("\n");
            sb.Append("  Message: ").Append(Message).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // PublicationServiceRorId (string) minLength
            if (this.PublicationServiceRorId != null && this.PublicationServiceRorId.Length < 1)
            {
                yield return new ValidationResult("Invalid value for PublicationServiceRorId, length must be greater than 1.", new [] { "PublicationServiceRorId" });
            }

            yield break;
        }
    }

}
