/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a Data Transfer Object (DTO) for resource details.
    /// </summary>
    [DataContract(Name = "ResourceDto")]
    public partial class ResourceDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ResourceDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceDto" /> class.
        /// </summary>
        /// <param name="id">Unique identifier for the resource..</param>
        /// <param name="pid">Persistent identifier for the resource. (required).</param>
        /// <param name="type">type (required).</param>
        /// <param name="name">Name of the resource. (required).</param>
        /// <param name="displayName">Display name of the resource. (required).</param>
        /// <param name="description">Description of the resource. (required).</param>
        /// <param name="keywords">Keywords associated with the resource..</param>
        /// <param name="license">license.</param>
        /// <param name="usageRights">Usage rights associated with the resource..</param>
        /// <param name="metadataLocalCopy">Setting for creating a local copy of the metadata..</param>
        /// <param name="metadataExtraction">Setting for metadata extraction..</param>
        /// <param name="applicationProfile">applicationProfile (required).</param>
        /// <param name="fixedValues">Fixed values associated with resource manipulation.  This dictionary may contain multiple levels and is structured as follows:  Dictionary (Key: string) -&gt; Dictionary (Key: string) -&gt; List of FixedValueForResourceManipulationDto. (required).</param>
        /// <param name="disciplines">Disciplines associated with the resource. (required).</param>
        /// <param name="visibility">visibility (required).</param>
        /// <param name="dateCreated">Date when the resource was created..</param>
        /// <param name="creator">creator.</param>
        /// <param name="archived">Indicates whether the resource is archived..</param>
        /// <param name="projects">The projects associated with the resource..</param>
        public ResourceDto(Guid id = default(Guid), string pid = default(string), ResourceTypeDto type = default(ResourceTypeDto), string name = default(string), string displayName = default(string), string description = default(string), List<string> keywords = default(List<string>), LicenseDto license = default(LicenseDto), string usageRights = default(string), bool metadataLocalCopy = default(bool), bool metadataExtraction = default(bool), ApplicationProfileMinimalDto applicationProfile = default(ApplicationProfileMinimalDto), Dictionary<string, Dictionary<string, List<FixedValueForResourceManipulationDto>>> fixedValues = default(Dictionary<string, Dictionary<string, List<FixedValueForResourceManipulationDto>>>), List<DisciplineDto> disciplines = default(List<DisciplineDto>), VisibilityDto visibility = default(VisibilityDto), DateTime? dateCreated = default(DateTime?), UserMinimalDto creator = default(UserMinimalDto), bool archived = default(bool), List<ProjectMinimalDto> projects = default(List<ProjectMinimalDto>))
        {
            // to ensure "pid" is required (not null)
            if (pid == null)
            {
                throw new ArgumentNullException("pid is a required property for ResourceDto and cannot be null");
            }
            this.Pid = pid;
            // to ensure "type" is required (not null)
            if (type == null)
            {
                throw new ArgumentNullException("type is a required property for ResourceDto and cannot be null");
            }
            this.Type = type;
            // to ensure "name" is required (not null)
            if (name == null)
            {
                throw new ArgumentNullException("name is a required property for ResourceDto and cannot be null");
            }
            this.Name = name;
            // to ensure "displayName" is required (not null)
            if (displayName == null)
            {
                throw new ArgumentNullException("displayName is a required property for ResourceDto and cannot be null");
            }
            this.DisplayName = displayName;
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new ArgumentNullException("description is a required property for ResourceDto and cannot be null");
            }
            this.Description = description;
            // to ensure "applicationProfile" is required (not null)
            if (applicationProfile == null)
            {
                throw new ArgumentNullException("applicationProfile is a required property for ResourceDto and cannot be null");
            }
            this.ApplicationProfile = applicationProfile;
            // to ensure "fixedValues" is required (not null)
            if (fixedValues == null)
            {
                throw new ArgumentNullException("fixedValues is a required property for ResourceDto and cannot be null");
            }
            this.FixedValues = fixedValues;
            // to ensure "disciplines" is required (not null)
            if (disciplines == null)
            {
                throw new ArgumentNullException("disciplines is a required property for ResourceDto and cannot be null");
            }
            this.Disciplines = disciplines;
            // to ensure "visibility" is required (not null)
            if (visibility == null)
            {
                throw new ArgumentNullException("visibility is a required property for ResourceDto and cannot be null");
            }
            this.Visibility = visibility;
            this.Id = id;
            this.Keywords = keywords;
            this.License = license;
            this.UsageRights = usageRights;
            this.MetadataLocalCopy = metadataLocalCopy;
            this.MetadataExtraction = metadataExtraction;
            this.DateCreated = dateCreated;
            this.Creator = creator;
            this.Archived = archived;
            this.Projects = projects;
        }

        /// <summary>
        /// Unique identifier for the resource.
        /// </summary>
        /// <value>Unique identifier for the resource.</value>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public Guid Id { get; set; }

        /// <summary>
        /// Persistent identifier for the resource.
        /// </summary>
        /// <value>Persistent identifier for the resource.</value>
        [DataMember(Name = "pid", IsRequired = true, EmitDefaultValue = true)]
        public string Pid { get; set; }

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name = "type", IsRequired = true, EmitDefaultValue = true)]
        public ResourceTypeDto Type { get; set; }

        /// <summary>
        /// Name of the resource.
        /// </summary>
        /// <value>Name of the resource.</value>
        [DataMember(Name = "name", IsRequired = true, EmitDefaultValue = true)]
        public string Name { get; set; }

        /// <summary>
        /// Display name of the resource.
        /// </summary>
        /// <value>Display name of the resource.</value>
        [DataMember(Name = "displayName", IsRequired = true, EmitDefaultValue = true)]
        public string DisplayName { get; set; }

        /// <summary>
        /// Description of the resource.
        /// </summary>
        /// <value>Description of the resource.</value>
        [DataMember(Name = "description", IsRequired = true, EmitDefaultValue = true)]
        public string Description { get; set; }

        /// <summary>
        /// Keywords associated with the resource.
        /// </summary>
        /// <value>Keywords associated with the resource.</value>
        [DataMember(Name = "keywords", EmitDefaultValue = true)]
        public List<string> Keywords { get; set; }

        /// <summary>
        /// Gets or Sets License
        /// </summary>
        [DataMember(Name = "license", EmitDefaultValue = false)]
        public LicenseDto License { get; set; }

        /// <summary>
        /// Usage rights associated with the resource.
        /// </summary>
        /// <value>Usage rights associated with the resource.</value>
        [DataMember(Name = "usageRights", EmitDefaultValue = true)]
        public string UsageRights { get; set; }

        /// <summary>
        /// Setting for creating a local copy of the metadata.
        /// </summary>
        /// <value>Setting for creating a local copy of the metadata.</value>
        [DataMember(Name = "metadataLocalCopy", EmitDefaultValue = true)]
        public bool MetadataLocalCopy { get; set; }

        /// <summary>
        /// Setting for metadata extraction.
        /// </summary>
        /// <value>Setting for metadata extraction.</value>
        [DataMember(Name = "metadataExtraction", EmitDefaultValue = true)]
        public bool MetadataExtraction { get; set; }

        /// <summary>
        /// Gets or Sets ApplicationProfile
        /// </summary>
        [DataMember(Name = "applicationProfile", IsRequired = true, EmitDefaultValue = true)]
        public ApplicationProfileMinimalDto ApplicationProfile { get; set; }

        /// <summary>
        /// Fixed values associated with resource manipulation.  This dictionary may contain multiple levels and is structured as follows:  Dictionary (Key: string) -&gt; Dictionary (Key: string) -&gt; List of FixedValueForResourceManipulationDto.
        /// </summary>
        /// <value>Fixed values associated with resource manipulation.  This dictionary may contain multiple levels and is structured as follows:  Dictionary (Key: string) -&gt; Dictionary (Key: string) -&gt; List of FixedValueForResourceManipulationDto.</value>
        [DataMember(Name = "fixedValues", IsRequired = true, EmitDefaultValue = true)]
        public Dictionary<string, Dictionary<string, List<FixedValueForResourceManipulationDto>>> FixedValues { get; set; }

        /// <summary>
        /// Disciplines associated with the resource.
        /// </summary>
        /// <value>Disciplines associated with the resource.</value>
        [DataMember(Name = "disciplines", IsRequired = true, EmitDefaultValue = true)]
        public List<DisciplineDto> Disciplines { get; set; }

        /// <summary>
        /// Gets or Sets Visibility
        /// </summary>
        [DataMember(Name = "visibility", IsRequired = true, EmitDefaultValue = true)]
        public VisibilityDto Visibility { get; set; }

        /// <summary>
        /// Date when the resource was created.
        /// </summary>
        /// <value>Date when the resource was created.</value>
        [DataMember(Name = "dateCreated", EmitDefaultValue = true)]
        public DateTime? DateCreated { get; set; }

        /// <summary>
        /// Gets or Sets Creator
        /// </summary>
        [DataMember(Name = "creator", EmitDefaultValue = false)]
        public UserMinimalDto Creator { get; set; }

        /// <summary>
        /// Indicates whether the resource is archived.
        /// </summary>
        /// <value>Indicates whether the resource is archived.</value>
        [DataMember(Name = "archived", EmitDefaultValue = true)]
        public bool Archived { get; set; }

        /// <summary>
        /// The projects associated with the resource.
        /// </summary>
        /// <value>The projects associated with the resource.</value>
        [DataMember(Name = "projects", EmitDefaultValue = true)]
        public List<ProjectMinimalDto> Projects { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourceDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Pid: ").Append(Pid).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  DisplayName: ").Append(DisplayName).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Keywords: ").Append(Keywords).Append("\n");
            sb.Append("  License: ").Append(License).Append("\n");
            sb.Append("  UsageRights: ").Append(UsageRights).Append("\n");
            sb.Append("  MetadataLocalCopy: ").Append(MetadataLocalCopy).Append("\n");
            sb.Append("  MetadataExtraction: ").Append(MetadataExtraction).Append("\n");
            sb.Append("  ApplicationProfile: ").Append(ApplicationProfile).Append("\n");
            sb.Append("  FixedValues: ").Append(FixedValues).Append("\n");
            sb.Append("  Disciplines: ").Append(Disciplines).Append("\n");
            sb.Append("  Visibility: ").Append(Visibility).Append("\n");
            sb.Append("  DateCreated: ").Append(DateCreated).Append("\n");
            sb.Append("  Creator: ").Append(Creator).Append("\n");
            sb.Append("  Archived: ").Append(Archived).Append("\n");
            sb.Append("  Projects: ").Append(Projects).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
