/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a Data Transfer Object (DTO) for search results.
    /// </summary>
    [DataContract(Name = "SearchResultDto")]
    public partial class SearchResultDto : IValidatableObject
    {

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name = "type", IsRequired = true, EmitDefaultValue = true)]
        public SearchCategoryType Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="SearchResultDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected SearchResultDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="SearchResultDto" /> class.
        /// </summary>
        /// <param name="uri">The URI associated with the search result. (required).</param>
        /// <param name="type">type (required).</param>
        /// <param name="source">The dynamic source data for the search result. (required).</param>
        public SearchResultDto(string uri = default(string), SearchCategoryType type = default(SearchCategoryType), Object source = default(Object))
        {
            // to ensure "uri" is required (not null)
            if (uri == null)
            {
                throw new ArgumentNullException("uri is a required property for SearchResultDto and cannot be null");
            }
            this.Uri = uri;
            this.Type = type;
            // to ensure "source" is required (not null)
            if (source == null)
            {
                throw new ArgumentNullException("source is a required property for SearchResultDto and cannot be null");
            }
            this.Source = source;
        }

        /// <summary>
        /// The URI associated with the search result.
        /// </summary>
        /// <value>The URI associated with the search result.</value>
        [DataMember(Name = "uri", IsRequired = true, EmitDefaultValue = true)]
        public string Uri { get; set; }

        /// <summary>
        /// The dynamic source data for the search result.
        /// </summary>
        /// <value>The dynamic source data for the search result.</value>
        [DataMember(Name = "source", IsRequired = true, EmitDefaultValue = true)]
        public Object Source { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class SearchResultDto {\n");
            sb.Append("  Uri: ").Append(Uri).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  Source: ").Append(Source).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
